3 # Copyright (c) 2005 Junio C Hamano.
6 USAGE
='[--interactive | -i] [-v] [--force-rebase | -f] [--no-ff] [--onto <newbase>] (<upstream>|--root) [<branch>] [--quiet | -q]'
7 LONG_USAGE
='git-rebase replaces <branch> with a new branch of the
8 same name. When the --onto option is provided the new branch starts
9 out with a HEAD equal to <newbase>, otherwise it is equal to <upstream>
10 It then attempts to create a new commit for each commit from the original
11 <branch> that does not exist in the <upstream> branch.
13 It is possible that a merge failure will prevent this process from being
14 completely automatic. You will have to resolve any such merge failure
15 and run git rebase --continue. Another option is to bypass the commit
16 that caused the merge failure with git rebase --skip. To restore the
17 original <branch> and remove the .git/rebase-apply working files, use the
18 command git rebase --abort instead.
20 Note that if <branch> is not specified on the command line, the
21 currently checked out branch is used.
23 Example: git-rebase master~1 topic
25 A---B---C topic A'\''--B'\''--C'\'' topic
27 D---E---F---G master D---E---F---G master
33 set_reflog_action rebase
39 OK_TO_SKIP_PRE_REBASE
=
41 When you have resolved this problem run \"git rebase --continue\".
42 If you would prefer to skip this patch, instead run \"git rebase --skip\".
43 To restore the original branch and stop rebasing run \"git rebase --abort\".
48 dotest
="$GIT_DIR"/rebase-merge
51 diffstat
=$
(git config
--bool rebase.stat
)
55 allow_rerere_autoupdate
=
59 test -n "$prev_head" || die
"prev_head must be defined"
60 test -d "$dotest" || die
"$dotest directory does not exist"
62 unmerged
=$
(git ls-files
-u)
63 if test -n "$unmerged"
65 echo "You still have unmerged paths in your index"
66 echo "did you forget to use git add?"
70 cmt
=`cat "$dotest/current"`
71 if ! git diff-index
--quiet --ignore-submodules HEAD
--
73 if ! git commit
--no-verify -C "$cmt"
75 echo "Commit failed, please do not call \"git commit\""
76 echo "directly, but instead do one of the following: "
79 if test -z "$GIT_QUIET"
81 printf "Committed: %0${prec}d " $msgnum
83 echo "$cmt $(git rev-parse HEAD^0)" >> "$dotest/rewritten"
85 if test -z "$GIT_QUIET"
87 printf "Already applied: %0${prec}d " $msgnum
90 test -z "$GIT_QUIET" &&
91 GIT_PAGER
='' git log
--format=%s
-1 "$cmt"
93 prev_head
=`git rev-parse HEAD^0`
94 # save the resulting commit so we can read-tree on it later
95 echo "$prev_head" > "$dotest/prev_head"
97 # onto the next patch:
98 msgnum
=$
(($msgnum + 1))
99 echo "$msgnum" >"$dotest/msgnum"
103 cmt
="$(cat "$dotest/cmt.
$1")"
104 echo "$cmt" > "$dotest/current"
105 hd
=$
(git rev-parse
--verify HEAD
)
106 cmt_name
=$
(git symbolic-ref HEAD
2> /dev
/null ||
echo HEAD
)
107 msgnum
=$
(cat "$dotest/msgnum")
108 end
=$
(cat "$dotest/end")
109 eval GITHEAD_
$cmt='"${cmt_name##refs/heads/}~$(($end - $msgnum))"'
110 eval GITHEAD_
$hd='$(cat "$dotest/onto_name")'
111 export GITHEAD_
$cmt GITHEAD_
$hd
112 if test -n "$GIT_QUIET"
114 export GIT_MERGE_VERBOSITY
=1
116 git-merge-
$strategy "$cmt^" -- "$hd" "$cmt"
120 unset GITHEAD_
$cmt GITHEAD_
$hd
124 git rerere
$allow_rerere_autoupdate
128 echo "Strategy: $rv $strategy failed, try another" 1>&2
132 die
"Unknown exit code ($rv) from command:" \
133 "git-merge-$strategy $cmt^ -- HEAD $cmt"
138 move_to_original_branch
() {
139 test -z "$head_name" &&
140 head_name
="$(cat "$dotest"/head-name)" &&
141 onto
="$(cat "$dotest"/onto)" &&
142 orig_head
="$(cat "$dotest"/orig-head)"
145 message
="rebase finished: $head_name onto $onto"
146 git update-ref
-m "$message" \
147 $head_name $
(git rev-parse HEAD
) $orig_head &&
148 git symbolic-ref HEAD
$head_name ||
149 die
"Could not move back to $head_name"
155 move_to_original_branch
156 git notes copy
--for-rewrite=rebase
< "$dotest"/rewritten
157 if test -x "$GIT_DIR"/hooks
/post-rewrite
&&
158 test -s "$dotest"/rewritten
; then
159 "$GIT_DIR"/hooks
/post-rewrite rebase
< "$dotest"/rewritten
170 interactive_rebase
=explicit
173 -p|
--preserve-merges)
174 interactive_rebase
=implied
180 if [ "$interactive_rebase" = implied
]; then
185 test -n "$interactive_rebase" ||
test -f "$dotest"/interactive
188 run_pre_rebase_hook
() {
189 if test -z "$OK_TO_SKIP_PRE_REBASE" &&
190 test -x "$GIT_DIR/hooks/pre-rebase"
192 "$GIT_DIR/hooks/pre-rebase" ${1+"$@"} ||
193 die
"The pre-rebase hook refused to rebase."
197 test -f "$GIT_DIR"/rebase-apply
/applying
&&
198 die
'It looks like git-am is in progress. Cannot rebase.'
200 is_interactive
"$@" && exec git-rebase--interactive
"$@"
206 OK_TO_SKIP_PRE_REBASE
=yes
209 test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply ||
210 die
"No rebase in progress?"
212 git diff-files
--quiet --ignore-submodules ||
{
213 echo "You must edit all merge conflicts and then"
214 echo "mark them as resolved using git add"
219 prev_head
=$
(cat "$dotest/prev_head")
220 end
=$
(cat "$dotest/end")
221 msgnum
=$
(cat "$dotest/msgnum")
222 onto
=$
(cat "$dotest/onto")
223 GIT_QUIET
=$
(cat "$dotest/quiet")
225 while test "$msgnum" -le "$end"
233 head_name
=$
(cat "$GIT_DIR"/rebase-apply
/head-name
) &&
234 onto
=$
(cat "$GIT_DIR"/rebase-apply
/onto
) &&
235 orig_head
=$
(cat "$GIT_DIR"/rebase-apply
/orig-head
) &&
236 GIT_QUIET
=$
(cat "$GIT_DIR"/rebase-apply
/quiet
)
237 git am
--resolved --3way --resolvemsg="$RESOLVEMSG" &&
238 move_to_original_branch
242 test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply ||
243 die
"No rebase in progress?"
245 git
reset --hard HEAD ||
exit $?
249 prev_head
=$
(cat "$dotest/prev_head")
250 end
=$
(cat "$dotest/end")
251 msgnum
=$
(cat "$dotest/msgnum")
252 msgnum
=$
(($msgnum + 1))
253 onto
=$
(cat "$dotest/onto")
254 GIT_QUIET
=$
(cat "$dotest/quiet")
255 while test "$msgnum" -le "$end"
263 head_name
=$
(cat "$GIT_DIR"/rebase-apply
/head-name
) &&
264 onto
=$
(cat "$GIT_DIR"/rebase-apply
/onto
) &&
265 orig_head
=$
(cat "$GIT_DIR"/rebase-apply
/orig-head
) &&
266 GIT_QUIET
=$
(cat "$GIT_DIR"/rebase-apply
/quiet
)
267 git am
-3 --skip --resolvemsg="$RESOLVEMSG" &&
268 move_to_original_branch
272 test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply ||
273 die
"No rebase in progress?"
278 GIT_QUIET
=$
(cat "$dotest/quiet")
279 move_to_original_branch
281 dotest
="$GIT_DIR"/rebase-apply
282 GIT_QUIET
=$
(cat "$dotest/quiet")
283 move_to_original_branch
285 git
reset --hard $
(cat "$dotest/orig-head")
290 test 2 -le "$#" || usage
294 -M|
-m|
--m|
--me|
--mer|
--merg|
--merge)
297 -s=*|
--s=*|
--st=*|
--str=*|
--stra=*|
--strat=*|
--strate=*|\
298 --strateg=*|
--strategy=*|\
299 -s|
--s|
--st|
--str|
--stra|
--strat|
--strate|
--strateg|
--strategy)
302 strategy
=`expr "z$1" : 'z-[^=]*=\(.*\)'` ;;
324 git_am_opt
="$git_am_opt -q"
329 git_am_opt
="$git_am_opt $1"
331 --whitespace=fix|
--whitespace=strip
)
337 git_am_opt
="$git_am_opt $1"
339 --committer-date-is-author-date|
--ignore-date)
340 git_am_opt
="$git_am_opt $1"
344 git_am_opt
="$git_am_opt $1"
349 -f|
--f|
--fo|
--for|
--forc|force|
--force-r|
--force-re|
--force-reb|
--force-reba|
--force-rebas|
--force-rebase|
--no-ff)
352 --rerere-autoupdate|
--no-rerere-autoupdate)
353 allow_rerere_autoupdate
="$1"
356 git_am_opt
="$git_am_opt --add-commit-name"
368 test $# -gt 2 && usage
370 if test $# -eq 0 && test -z "$rebase_root"
372 test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply || usage
373 test -d "$dotest" -o -f "$GIT_DIR"/rebase-apply
/rebasing
&&
374 die
'A rebase is in progress, try --continue, --skip or --abort.'
377 # Make sure we do not have $GIT_DIR/rebase-apply
378 if test -z "$do_merge"
380 if mkdir
"$GIT_DIR"/rebase-apply
2>/dev
/null
382 rmdir "$GIT_DIR"/rebase-apply
385 It seems that I cannot create a rebase-apply directory, and
386 I wonder if you are in the middle of patch application or another
387 rebase. If that is not the case, please
388 rm -fr '"$GIT_DIR"'/rebase-apply
389 and run me again. I am stopping in case you still have something
396 die
"previous rebase directory $dotest still exists." \
397 'Try git rebase (--continue | --abort | --skip)'
399 if test -n "$add_commit_name"
401 die
"-x not compatible with --merge"
405 # The tree must be really really clean.
406 if ! git update-index
--ignore-submodules --refresh > /dev
/null
; then
407 echo >&2 "cannot rebase: you have unstaged changes"
408 git diff-files
--name-status -r --ignore-submodules -- >&2
411 diff=$
(git diff-index
--cached --name-status -r --ignore-submodules HEAD
--)
413 ?
*) echo >&2 "cannot rebase: your index contains uncommitted changes"
419 if test -z "$rebase_root"
421 # The upstream head must be given. Make sure it is valid.
424 upstream
=`git rev-parse --verify "${upstream_name}^0"` ||
425 die
"invalid upstream $upstream_name"
427 upstream_arg
="$upstream_name"
429 test -z "$newbase" && die
"--root must be used with --onto"
433 upstream_arg
="$root_flag"
436 # Make sure the branch to rebase onto is valid.
437 onto_name
=${newbase-"$upstream_name"}
440 if left
=${onto_name%...*} right
=${onto_name#*...} &&
441 onto
=$
(git merge-base
--all ${left:-HEAD} ${right:-HEAD})
445 die
"$onto_name: there are more than one merge bases"
448 die
"$onto_name: there is no merge base"
452 die
"$onto_name: there is no merge base"
456 onto
=$
(git rev-parse
--verify "${onto_name}^0") ||
exit
460 # If a hook exists, give it a chance to interrupt
461 run_pre_rebase_hook
"$upstream_arg" "$@"
463 # If the branch to rebase is given, that is the branch we will rebase
464 # $branch_name -- branch being rebased, or HEAD (already detached)
465 # $orig_head -- commit object name of tip of the branch before rebasing
466 # $head_name -- refs/heads/<that-branch> or "detached HEAD"
470 # Is it "rebase other $branchname" or "rebase other $commit"?
474 if git show-ref
--verify --quiet -- "refs/heads/$1" &&
475 branch
=$
(git rev-parse
-q --verify "refs/heads/$1")
477 head_name
="refs/heads/$1"
478 elif branch
=$
(git rev-parse
-q --verify "$1")
480 head_name
="detached HEAD"
486 # Do not need to switch branches, we are already on it.
487 if branch_name
=`git symbolic-ref -q HEAD`
489 head_name
=$branch_name
490 branch_name
=`expr "z$branch_name" : 'zrefs/heads/\(.*\)'`
492 head_name
="detached HEAD"
493 branch_name
=HEAD
;# detached
495 branch
=$
(git rev-parse
--verify "${branch_name}^0") ||
exit
500 # Now we are rebasing commits $upstream..$branch (or with --root,
501 # everything leading up to $branch) on top of $onto
503 # Check if we are already based on $onto with linear history,
504 # but this should be done only when upstream and onto are the same.
505 mb
=$
(git merge-base
"$onto" "$branch")
506 if test "$upstream" = "$onto" && test "$mb" = "$onto" &&
508 ! (git rev-list
--parents "$onto"..
"$branch" | sane_grep
" .* ") > /dev
/null
510 if test -z "$force_rebase"
512 # Lazily switch to the target branch if needed...
513 test -z "$switch_to" || git checkout
"$switch_to"
514 say
"Current branch $branch_name is up to date."
517 say
"Current branch $branch_name is up to date, rebase forced."
521 # Detach HEAD and reset the tree
522 say
"First, rewinding head to replay your work on top of it..."
523 git checkout
-q "$onto^0" || die
"could not detach HEAD"
524 git update-ref ORIG_HEAD
$branch
526 if test -n "$diffstat"
528 if test -n "$verbose"
530 echo "Changes from $mb to $onto:"
532 # We want color (if set), but no pager
533 GIT_PAGER
='' git
diff --stat --summary "$mb" "$onto"
536 # If the $onto is a proper descendant of the tip of the branch, then
537 # we just fast-forwarded.
538 if test "$mb" = "$branch"
540 say
"Fast-forwarded $branch_name to $onto_name."
541 move_to_original_branch
545 if test -n "$rebase_root"
547 revisions
="$onto..$orig_head"
549 revisions
="$upstream..$orig_head"
552 if test -z "$do_merge"
554 git format-patch
-k --stdout --full-index --ignore-if-in-upstream \
555 $root_flag "$revisions" |
556 git am
$git_am_opt --rebasing --resolvemsg="$RESOLVEMSG" &&
557 move_to_original_branch
559 test 0 != $ret -a -d "$GIT_DIR"/rebase-apply
&&
560 echo $head_name > "$GIT_DIR"/rebase-apply
/head-name
&&
561 echo $onto > "$GIT_DIR"/rebase-apply
/onto
&&
562 echo $orig_head > "$GIT_DIR"/rebase-apply
/orig-head
&&
563 echo "$GIT_QUIET" > "$GIT_DIR"/rebase-apply
/quiet
567 # start doing a rebase with git-merge
568 # this is rename-aware if the recursive (default) strategy is used
571 echo "$onto" > "$dotest/onto"
572 echo "$onto_name" > "$dotest/onto_name"
574 echo "$prev_head" > "$dotest/prev_head"
575 echo "$orig_head" > "$dotest/orig-head"
576 echo "$head_name" > "$dotest/head-name"
577 echo "$GIT_QUIET" > "$dotest/quiet"
580 for cmt
in `git rev-list --reverse --no-merges "$revisions"`
582 msgnum
=$
(($msgnum + 1))
583 echo "$cmt" > "$dotest/cmt.$msgnum"
586 echo 1 >"$dotest/msgnum"
587 echo $msgnum >"$dotest/end"
592 while test "$msgnum" -le "$end"